/*
 * Created on 24.04.2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package pipes;

import clustering.AbstractDistance;
import clustering.Distance;
import clustering.KMeans;
import clustering.KMeansUtils;
import clustering.RelativeKMeans;

/**
 * @author beringer
 */
public class StreamCluster extends StreamingKMeans {

    static public Distance getDFTDistance(final int dftCount) {
        return new AbstractDistance() {
            Distance internal = KMeansUtils.getComplexDistance(dftCount);

            public double squaredDistance(Object ob1, Object ob2) {
                return internal.squaredDistance(ob1, ob2) * 2;
            }
        };
    }

    public StreamCluster(String[] streamNames, int size, int blockCount,
            int dftCount, int clusterCount) {
        this(streamNames, size, blockCount, dftCount, clusterCount,
                clusterCount);
    }

    /** Creates a new instance of StreamCluster */
    public StreamCluster(String[] streamNames, int size, int blockCount,
            int dftCount, int maxClusterCount, int clusterCount) {

        this(new KMeans(getDFTDistance(dftCount), KMeans.OBJECTIVE,
                KMeans.SEPARATION, KMeans.INITALIZE, KMeansUtils
                        .getComplexCopyFunction(dftCount), KMeansUtils
                        .getComplexMeansFunction(dftCount)), streamNames, size,
                blockCount, maxClusterCount, clusterCount);

    }

    public StreamCluster(KMeans kmeans, String[] streamNames, int size,
            int blockCount, int maxClusterCount, int clusterCount) {

        super(new RelativeKMeans(kmeans), streamNames, size, blockCount,
                maxClusterCount, clusterCount);

    }

    /*
     * public void writeUltschData() { try { PrintStream ps= new PrintStream(new
     * FileOutputStream("C:\\data.txt")); ps.print("Key\t");
     * 
     * int dftCount= 0; //((KMeansComplex) kmAlg).length;
     * 
     * for (int j= 0; j < dftCount; j++) { ps.print("V" + (2 * j + 1) + "\t");
     * ps.print("V" + (2 * j + 2) + "\t"); } ps.print("Clusternumber\n");
     * 
     * for (int j= 0; j < size; j++) { ps.print(streamsObjects[j] + "\t"); for
     * (int i= 0; i < dftCount; i++) { ps.print(((double[][]) data[j])[i][0] +
     * "\t"); ps.print(((double[][]) data[j])[i][1] + "\t"); }
     * ps.print(cluster[j]); if ((j + 1) < size) ps.print("\n"); } ps.flush();
     * ps.close(); } catch (Exception e) { } }
     */
}
