/*
 * Created on 20.08.2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package clustering;

import xxl.core.functions.Function;

/**
 * @author beringer
 */
public interface FuzzyKMeansClustering {
    

    public abstract Distance getDistance();

    public abstract double getFuzzifier();

    public abstract void initialize(FuzzyKMeansState state);

    /**
     * invoke the fuzzy kmeans algorithm.
     * 
     * @param data
     *            the data to cluster
     * @param dataCount
     *            data count
     * @param clusterCount
     *            cluster count (k)
     * @param epsilon
     *            stop if upgrade lower epsilon
     * @return the membership degrees of all data to all clusters
     */
    public abstract FuzzyKMeansState invokeFuzzyKMeans(Object[] data, int dataCount,
            int clusterCount, double epsilon);

    /**
     * Compute degrees of memberships
     * @param state TODO
     * @param clusterDist
     *            squared distances of data to each cluster center (return)
     */
    public abstract void computeMemberships(FuzzyKMeansState state);

    public abstract double[][] computeMembership(Object[] kmeans,
            int clusterCount, Object[] ob);

    public abstract double[] computeMembership(Object[] kmeans,
            int clusterCount, Object ob);

    public abstract void computeClusterCenters(FuzzyKMeansState state);

    public abstract double computeValidity(FuzzyKMeansState state);

    public abstract double computeObjective(FuzzyKMeansState state);

    public abstract Function getCopyFunction();
}